<?php
namespace Teknisa\TCO\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\GER\Utilities\Environment;
use Teknisa\GER\Utilities\DataSourceUtil;

class Tco00700TipoDePublicoService extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $entityManager;

    public function __construct(EntityManager $entityManager, Environment $environment) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }
    
    public function retornaTiposDePublicoUtilizados($tipoPublico) {
        $connection = $this->entityManager->getConnection();
        $sql = "SELECT
                MESSAGECODE,
                PARAM1,
                PARAM2,
                PARAM3
            FROM
                ( 
                        /*Tipo de público em uso na regra de gramatura __PARAM1__ do grupo __PARAM2__ no cardápio base __PARAM3__*/
                    SELECT
                        'TCO00700_TIPOPUBLICO_EM_USO_GRAMATURACARDBASE' AS MESSAGECODE,
                        TO_CHAR(G.VRGRAMATURA)
                        || ' '
                        || G.SGUNIDADE AS PARAM1,
                        GR.CDGRTIPOPR
                        || ' '
                        || GR.NMGRTIPOPR AS PARAM2,
                        C.CDCARDAPIOBASE AS PARAM3
                    FROM
                        GRAMATURACARDBASE G
                        INNER JOIN GRTIPOPR GR ON GR.CDGRTIPOPR = G.CDGRTIPOPR
                        INNER JOIN CARDAPIOBASE C ON C.NRCARDAPIOBASE = G.NRCARDAPIOBASE
                    WHERE
                        G.NRTIPOPUBLICO =:NRTIPOPUBLICO
                    UNION ALL
                         
                         /*Tipo de público em uso no serviço __PARAM1__ da versão __PARAM2__ na proposta comercial __PARAM3__*/
                    SELECT
                        'TCO00700_TIPOPUBLICO_EM_USO_SERVICOPROPCOM' AS MESSAGECODE,
                        SP.CDSERVICOPROPOSTA
                        || ' - '
                        || SP.NMSERVICOPROPOSTA AS PARAM1,
                        V.CDVERSAOPROPCOM AS PARAM2,
                        P.CDPROPOSTACOMERCIAL AS PARAM3
                    FROM
                        SERVICOPROPCOM S
                        INNER JOIN SERVICOPROPOSTA SP ON SP.NRSERVICOPROPOSTA = S.NRSERVICOPROPOSTA
                        INNER JOIN VERSAOPROPCOM V ON V.NRVERSAOPROPCOM = S.NRVERSAOPROPCOM
                        INNER JOIN PROPOSTACOMERCIAL P ON P.NRPROPOSTACOMERCIAL = V.NRPROPOSTACOMERCIAL
                    WHERE
                        S.NRTIPOPUBLICO =:NRTIPOPUBLICO
                    UNION ALL
                         
                         /*Tipo de público em uso no serviço de planejamento __PARAM1__ da filial __PARAM2__*/
                    SELECT
                        'TCO00700_TIPOPUBLICO_EM_USO_SERVICO' AS MESSAGECODE,
                        S.CDSERVFILI
                        || ' - '
                        || S.NMSERVICO AS PARAM1,
                        S.CDFILIAL AS PARAM2,
                        NULL AS PARAM3
                    FROM
                        SERVICO S
                    WHERE
                        S.NRTIPOPUBLICO =:NRTIPOPUBLICO
                )";
        
        $query = $connection->prepare($sql);
        
        $params = array(
            'NRTIPOPUBLICO' => $tipoPublico[0]['NRTIPOPUBLICO']
        ); 
        $query->execute($params);
        
        $result = $query->fetchAll(\PDO::FETCH_ASSOC);
        
        return $result;
        
    }
}